-- Test add_campsite
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

set search_path to camper, public;

select plan(14);

select has_function('camper', 'add_campsite', array ['integer', 'text']);
select function_lang_is('camper', 'add_campsite', array ['integer', 'text'], 'plpgsql');
select function_returns('camper', 'add_campsite', array ['integer', 'text'], 'uuid');
select isnt_definer('camper', 'add_campsite', array ['integer', 'text']);
select volatility_is('camper', 'add_campsite', array ['integer', 'text'], 'volatile');
select function_privs_are('camper', 'add_campsite', array ['integer', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'add_campsite', array ['integer', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'add_campsite', array ['integer', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'add_campsite', array ['integer', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite cascade;
truncate campsite_type cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', 'ES', 'EUR', 'ca')
     , (2, 'Company 4', 'XX234', '', '666-666-666', 'b@b', '', '', '', '', '', 'FR', 'USD', 'ca')
;

insert into campsite_type (campsite_type_id, company_id, name)
values (11, 1, 'A')
     , (12, 1, 'B')
     , (21, 2, 'C')
;

select lives_ok(
	$$ select add_campsite(11, 'A1') $$,
	'Should be able to add a campsite to the first company'
);

select lives_ok(
	$$ select add_campsite(12, 'B1') $$,
	'Should be able to add a campsite to the same company, but of a different type'
);

select lives_ok(
	$$ select add_campsite(21, 'C1') $$,
	'Should be able to add a campsite to the second company'
);

select throws_ok(
	$$ select add_campsite(22, 'C1') $$,
	'23503', 'insert or update on table "campsite" violates foreign key constraint "campsite_campsite_type_id_fkey"',
	'Should raise an error if the campsite type is not valid.'
);

select bag_eq(
	$$ select company_id, campsite_type_id, label, active from campsite $$,
	$$ values (1, 11, 'A1', true)
	        , (1, 12, 'B1', true)
	        , (2, 21, 'C1', true)
	$$,
	'Should have added all campsites'
);

select *
from finish();

rollback;
